import { ref as b, defineComponent as _, openBlock as i, createElementBlock as c, createElementVNode as n, Fragment as g, renderSlot as u, onMounted as f, nextTick as T, createVNode as C, createSlots as N, withCtx as V, unref as w, pushScopeId as k, popScopeId as P, createBlock as x, normalizeProps as H, mergeProps as B, normalizeClass as y, createTextVNode as q, toDisplayString as A, createCommentVNode as $, computed as j } from "vue";
import { createHighlighter as D } from "shiki";
function M() {
  const t = b("");
  async function o(e, s) {
    const l = await D({
      langs: [],
      themes: Object.values(s)
    });
    await l.loadLanguage("templ"), t.value = l.codeToHtml(e, {
      lang: "templ",
      themes: s,
      defaultColor: !1
    });
  }
  return {
    highlightedCode: t,
    highlightCode: o
  };
}
function S() {
  const t = document.querySelector(
    ".preview-content"
  );
  t && (new MutationObserver((e) => {
    e.forEach((s) => {
      s.type === "childList" && F(s.target);
    });
  }).observe(t, { childList: !0 }), F(t));
}
function F(t) {
  t.querySelectorAll("script").forEach((e) => {
    var l;
    const s = document.createElement("script");
    s.textContent = e.textContent, (l = document.body.appendChild(s).parentNode) == null || l.removeChild(s);
  });
}
const W = ["width", "height", "fill"], G = /* @__PURE__ */ n("path", {
  "fill-rule": "evenodd",
  d: "M4.78 4.97a.75.75 0 0 1 0 1.06L2.81 8l1.97 1.97a.75.75 0 1 1-1.06 1.06l-2.5-2.5a.75.75 0 0 1 0-1.06l2.5-2.5a.75.75 0 0 1 1.06 0ZM11.22 4.97a.75.75 0 0 0 0 1.06L13.19 8l-1.97 1.97a.75.75 0 1 0 1.06 1.06l2.5-2.5a.75.75 0 0 0 0-1.06l-2.5-2.5a.75.75 0 0 0-1.06 0ZM8.856 2.008a.75.75 0 0 1 .636.848l-1.5 10.5a.75.75 0 0 1-1.484-.212l1.5-10.5a.75.75 0 0 1 .848-.636Z",
  "clip-rule": "evenodd"
}, null, -1), J = [
  G
], O = /* @__PURE__ */ _({
  __name: "CodeIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(t) {
    const o = t;
    return (e, s) => (i(), c("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: o.size,
      height: o.size,
      viewBox: "0 0 16 16",
      fill: o.fill,
      "aria-hidden": "true"
    }, J, 8, W));
  }
}), Q = /* @__PURE__ */ _({
  __name: "ConditionalWrapper",
  props: {
    isPreviewFirst: { type: Boolean }
  },
  setup(t) {
    const o = t;
    return (e, s) => (i(), c("div", null, [
      o.isPreviewFirst ? (i(), c(g, { key: 0 }, [
        u(e.$slots, "preview"),
        u(e.$slots, "code")
      ], 64)) : (i(), c(g, { key: 1 }, [
        u(e.$slots, "code"),
        u(e.$slots, "preview")
      ], 64))
    ]));
  }
}), z = (t) => (k("data-v-9e72d3da"), t = t(), P(), t), R = { class: "container" }, U = { class: "preview" }, X = ["innerHTML"], Y = { class: "code-content" }, ee = { class: "language-templ vp-adaptive-theme" }, te = /* @__PURE__ */ z(() => /* @__PURE__ */ n("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), oe = /* @__PURE__ */ z(() => /* @__PURE__ */ n("span", { class: "lang" }, "templ", -1)), ne = ["innerHTML"], se = /* @__PURE__ */ _({
  __name: "VTPCard",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(t) {
    const o = t, { highlightedCode: e, highlightCode: s } = M();
    return f(async () => {
      await s(o.codeContent, o.themes), T(() => {
        S();
      });
    }), (l, d) => (i(), c("div", R, [
      C(Q, {
        isPreviewFirst: o.isPreviewFirst
      }, N({
        preview: V(() => [
          n("div", U, [
            n("div", {
              class: "preview-content",
              innerHTML: o.htmlContent
            }, null, 8, X)
          ])
        ]),
        _: 2
      }, [
        o.isPreviewOnly ? void 0 : {
          name: "code",
          fn: V(() => [
            n("div", Y, [
              n("div", ee, [
                te,
                oe,
                n("span", {
                  class: "vp-code",
                  innerHTML: w(e)
                }, null, 8, ne)
              ])
            ])
          ]),
          key: "0"
        }
      ]), 1032, ["isPreviewFirst"])
    ]));
  }
}), L = (t, o) => {
  const e = t.__vccOpts || t;
  for (const [s, l] of o)
    e[s] = l;
  return e;
}, I = /* @__PURE__ */ L(se, [["__scopeId", "data-v-9e72d3da"]]), E = (t) => (k("data-v-e9474884"), t = t(), P(), t), ie = {
  key: 1,
  class: "container"
}, le = { class: "preview" }, ae = ["innerHTML"], ce = { class: "code-section" }, re = ["aria-hidden"], de = { class: "language-templ vp-adaptive-theme" }, pe = /* @__PURE__ */ E(() => /* @__PURE__ */ n("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), ve = /* @__PURE__ */ E(() => /* @__PURE__ */ n("span", { class: "lang" }, "templ", -1)), he = ["innerHTML"], ue = /* @__PURE__ */ _({
  __name: "VTPCodeToggle",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(t) {
    const o = t, e = b(!1), { highlightedCode: s, highlightCode: l } = M();
    function d() {
      e.value = !e.value;
    }
    return f(async () => {
      await l(o.codeContent, o.themes), T(() => {
        S();
      });
    }), (v, a) => o.isPreviewOnly ? (i(), x(I, H(B({ key: 0 }, o)), null, 16)) : (i(), c("div", ie, [
      n("div", le, [
        n("div", {
          class: "preview-content",
          innerHTML: o.htmlContent
        }, null, 8, ae)
      ]),
      n("div", ce, [
        n("button", {
          onClick: d,
          class: y(`button-${o.buttonStyle}`),
          "aria-label": "view the source code"
        }, [
          u(v.$slots, "code-icon", {}, () => [
            C(O, {
              fill: `var(--vp-button-${o.buttonStyle}-text)`
            }, null, 8, ["fill"])
          ], !0),
          q(" " + A(e.value ? "Hide Code" : "Show Code"), 1)
        ], 2),
        n("div", {
          class: "code-content",
          "aria-hidden": !e.value
        }, [
          n("div", null, [
            n("div", de, [
              pe,
              ve,
              n("span", {
                class: "vp-code",
                innerHTML: w(s)
              }, null, 8, he)
            ])
          ])
        ], 8, re)
      ])
    ]));
  }
}), We = /* @__PURE__ */ L(ue, [["__scopeId", "data-v-e9474884"]]), K = (t) => (k("data-v-cc63f3b2"), t = t(), P(), t), _e = { class: "wrapper" }, we = {
  class: "tabs",
  role: "tablist"
}, me = ["aria-selected"], ye = ["aria-selected"], ge = {
  class: "tab-content",
  role: "tabpanel"
}, Ce = ["innerHTML"], $e = {
  key: 1,
  class: "code-content"
}, be = { class: "language-templ vp-adaptive-theme" }, fe = /* @__PURE__ */ K(() => /* @__PURE__ */ n("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), Te = /* @__PURE__ */ K(() => /* @__PURE__ */ n("span", { class: "lang" }, "templ", -1)), ke = ["innerHTML"], Pe = /* @__PURE__ */ _({
  __name: "VTPTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(t) {
    const o = t, e = b("preview"), { highlightedCode: s, highlightCode: l } = M(), d = (v, a) => {
      (v.key === "Enter" || v.key === " ") && (e.value = a);
    };
    return f(async () => {
      await l(o.codeContent, o.themes), T(() => {
        S();
      });
    }), (v, a) => o.isPreviewOnly ? (i(), x(I, H(B({ key: 0 }, o)), null, 16)) : (i(), c(g, { key: 1 }, [
      n("div", _e, [
        n("div", we, [
          n("button", {
            role: "tab",
            "aria-selected": e.value === "preview",
            class: y({ active: e.value === "preview" }),
            onClick: a[0] || (a[0] = (p) => e.value = "preview"),
            onKeydown: a[1] || (a[1] = (p) => d(p, "preview")),
            tabindex: "0",
            "aria-label": "preview the component"
          }, " Preview ", 42, me),
          n("button", {
            role: "tab",
            "aria-selected": e.value === "code",
            class: y({ active: e.value === "code" }),
            onClick: a[2] || (a[2] = (p) => e.value = "code"),
            onKeydown: a[3] || (a[3] = (p) => d(p, "code")),
            tabindex: "0",
            "aria-label": "view the source code"
          }, " Code ", 42, ye)
        ])
      ]),
      n("div", ge, [
        e.value === "preview" ? (i(), c("div", {
          key: 0,
          class: "preview-content",
          innerHTML: o.htmlContent
        }, null, 8, Ce)) : $("", !0),
        e.value === "code" ? (i(), c("div", $e, [
          n("div", be, [
            fe,
            Te,
            n("span", {
              class: "vp-code",
              innerHTML: w(s)
            }, null, 8, ke)
          ])
        ])) : $("", !0)
      ])
    ], 64));
  }
}), Ge = /* @__PURE__ */ L(Pe, [["__scopeId", "data-v-cc63f3b2"]]), Me = ["width", "height", "fill"], Se = /* @__PURE__ */ n("path", { d: "M8 9.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z" }, null, -1), Le = /* @__PURE__ */ n("path", {
  "fill-rule": "evenodd",
  d: "M1.38 8.28a.87.87 0 0 1 0-.566 7.003 7.003 0 0 1 13.238.006.87.87 0 0 1 0 .566A7.003 7.003 0 0 1 1.379 8.28ZM11 8a3 3 0 1 1-6 0 3 3 0 0 1 6 0Z",
  "clip-rule": "evenodd"
}, null, -1), xe = [
  Se,
  Le
], He = /* @__PURE__ */ _({
  __name: "ViewIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(t) {
    const o = t;
    return (e, s) => (i(), c("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: o.size,
      height: o.size,
      viewBox: "0 0 16 16",
      fill: o.fill,
      "aria-hidden": "true"
    }, xe, 8, Me));
  }
}), Z = (t) => (k("data-v-e0e66a74"), t = t(), P(), t), Be = { class: "wrapper" }, Ie = {
  class: "tabs",
  role: "tablist"
}, Ve = ["aria-selected"], Fe = ["aria-selected"], Oe = {
  class: "tab-content",
  role: "tabpanel"
}, ze = ["innerHTML"], Ee = {
  key: 1,
  class: "code-content"
}, Ke = { class: "language-templ vp-adaptive-theme" }, Ze = /* @__PURE__ */ Z(() => /* @__PURE__ */ n("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), Ne = /* @__PURE__ */ Z(() => /* @__PURE__ */ n("span", { class: "lang" }, "templ", -1)), qe = ["innerHTML"], Ae = /* @__PURE__ */ _({
  __name: "VTPIconTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(t) {
    const o = t, e = b("preview"), { highlightedCode: s, highlightCode: l } = M(), d = (h) => j(() => e.value === h ? "var(--vp-button-brand-text)" : "var(--vp-button-alt-text)"), v = d("preview"), a = d("code"), p = (h, r) => {
      (h.key === "Enter" || h.key === " ") && (e.value = r);
    };
    return f(async () => {
      await l(o.codeContent, o.themes), T(() => {
        S();
      });
    }), (h, r) => o.isPreviewOnly ? (i(), x(I, H(B({ key: 0 }, o)), null, 16)) : (i(), c(g, { key: 1 }, [
      n("div", Be, [
        n("div", Ie, [
          n("button", {
            role: "tab",
            "aria-selected": e.value === "preview",
            class: y({ active: e.value === "preview" }),
            onClick: r[0] || (r[0] = (m) => e.value = "preview"),
            onKeydown: r[1] || (r[1] = (m) => p(m, "preview")),
            tabindex: "0",
            "aria-label": "preview the component"
          }, [
            u(h.$slots, "preview-icon", {}, () => [
              C(He, { fill: w(v) }, null, 8, ["fill"])
            ], !0)
          ], 42, Ve),
          n("button", {
            role: "tab",
            "aria-selected": e.value === "code",
            class: y({ active: e.value === "code" }),
            onClick: r[2] || (r[2] = (m) => e.value = "code"),
            onKeydown: r[3] || (r[3] = (m) => p(m, "code")),
            tabindex: "0",
            "aria-label": "view the source code"
          }, [
            u(h.$slots, "code-icon", {}, () => [
              C(O, { fill: w(a) }, null, 8, ["fill"])
            ], !0)
          ], 42, Fe)
        ])
      ]),
      n("div", Oe, [
        e.value === "preview" ? (i(), c("div", {
          key: 0,
          class: "preview-content",
          innerHTML: o.htmlContent
        }, null, 8, ze)) : $("", !0),
        e.value === "code" ? (i(), c("div", Ee, [
          n("div", Ke, [
            Ze,
            Ne,
            n("span", {
              class: "vp-code",
              innerHTML: w(s)
            }, null, 8, qe)
          ])
        ])) : $("", !0)
      ])
    ], 64));
  }
}), Je = /* @__PURE__ */ L(Ae, [["__scopeId", "data-v-e0e66a74"]]);
export {
  I as VTPCard,
  We as VTPCodeToggle,
  Je as VTPIconTabs,
  Ge as VTPTabs
};
